﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Infragistics.Win;
using Infragistics.Win.UltraWinSchedule;
using Infragistics.Win.UltraWinGrid;

namespace WinGantViewDataBind
{
    public partial class Form1 : Form
    {

        DataSet ds;

        private DataSet GetSampleData()
        {
            DataSet theDataSet = new DataSet();
                  //ds = new DataSet();
                  theDataSet.ReadXmlSchema("..\\..\\DataSet\\Schema.XML");
                  theDataSet.ReadXml("..\\..\\DataSet\\Data.XML");

            return theDataSet;
        }

        private void BindGanttView()
        {
            //  Set the BindingContextControl property to reference this form
            this.ultraCalendarInfo1.DataBindingsForTasks.BindingContextControl = this;
            this.ultraCalendarInfo1.DataBindingsForProjects.BindingContextControl = this;

            //  Set the DataBinding members for Projects 

            this.ultraCalendarInfo1.DataBindingsForProjects.SetDataBinding(ds, "Projects");
            this.ultraCalendarInfo1.DataBindingsForProjects.IdMember = "ProjectID";
            this.ultraCalendarInfo1.DataBindingsForProjects.KeyMember = "ProjectKey";
            this.ultraCalendarInfo1.DataBindingsForProjects.NameMember = "ProjectName";
            this.ultraCalendarInfo1.DataBindingsForProjects.StartDateMember = "ProjectStartTime";

            //  Set the DataBinding members for Tasks
            this.ultraCalendarInfo1.DataBindingsForTasks.SetDataBinding(ds, "Tasks");

            // Basic Task properties 
            this.ultraCalendarInfo1.DataBindingsForTasks.NameMember = "TaskName";
            this.ultraCalendarInfo1.DataBindingsForTasks.DurationMember = "TaskDuration";
            this.ultraCalendarInfo1.DataBindingsForTasks.StartDateTimeMember = "TaskStartTime";
            this.ultraCalendarInfo1.DataBindingsForTasks.IdMember = "TaskID";
            this.ultraCalendarInfo1.DataBindingsForTasks.ProjectKeyMember = "ProjectKey";
            this.ultraCalendarInfo1.DataBindingsForTasks.ParentTaskIdMember = "ParentTaskID";
            


            this.ultraCalendarInfo1.DataBindingsForTasks.PercentCompleteMember = "TaskPercentComplete";
            // All other properties
            this.ultraCalendarInfo1.DataBindingsForTasks.AllPropertiesMember = "AllProperties";

            

            //  Since we are showing a task that belongs to an explicitly defined
            //  project (i.e., not the UnassignedProject), assign that project to
            //  the control's Project property so the control knows to display that project.
            this.ganntView1.CalendarInfo = this.ultraCalendarInfo1;
            this.ganntView1.Project = this.ganntView1.CalendarInfo.Projects[1];


        }

        public Form1()
        {
            InitializeComponent();
            ds = this.GetSampleData();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            BindGanttView();
        }

        private void button1_Click(object sender, EventArgs e)
        {
            ds.WriteXml("..\\..\\DataSet\\Data.XML");
            ds.WriteXmlSchema("..\\..\\DataSet\\Schema.XML");
        }

        private void button2_Click(object sender, EventArgs e)
        {
            Task tp1 = ultraCalendarInfo1.Tasks[2].Tasks[0];
            Task tp2 = ultraCalendarInfo1.Tasks[2].Tasks[1];
            tp2.Dependencies.Add(tp1, TaskDependencyType.FinishToStart);
        }
    }
}
